<template lang="html">
  <butter-list
    :class="{ 'limit': limit, 'payment-method': true }"
    :subtitle="subtitle"
    :active="active"
    :details="limit"
    @click.native="$emit('click', id)">
    <p><slot></slot></p>
    <butter-icon v-if="fetchedSettings" class="settings" name="gear" @click.native.stop="fetchedSettings()" />
    <butter-icon slot="icon" :name="id" class="method-icon"></butter-icon>
  </butter-list>
</template>

<script>
export default {
  props: ['id','subtitle','active','settings','limit'],
  async mounted() {
    if(this.settings) {
      this.fetchedSettings = await this.settings;
    }
  },
  data() {
    return {
      fetchedSettings: false,
    };
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';

.payment-method.active .settings {
  @include themify($themes) {
    fill: themed('color-bg-primary');
  }
}
p {
  display: flex;
  flex-grow: 1;

  .payment-method.limit & {
    @include themify($themes) {
      color: themed('color-text-secondary');
    }
  }
  .payment-method.limit.active & {
    @include themify($themes) {
      color: themed('color-text-primary');
    }
  }
}
.payment-method.limit {
  @include themify($themes) {
    color: themed('color-text-secondary');
  }
  &.active {
    @include themify($themes) {
      color: themed('color-text-primary');
      background-color: themed('color-bg-secondary');
    }
  }
}
.method-icon {
  display: flex;
  height: $grid*4;
  width: $grid*4;

  .payment-method.active & {
    @include themify($themes) {
      fill: themed('color-bg-primary');
    }
  }
  .payment-method.limit & {
    @include themify($themes) {
      fill: themed('color-text-secondary');
    }
  }
}
.settings  {
  height: $grid*4;
  width: $grid*4;
  justify-self: flex-end;
  display: flex;
}
</style>
